# rechter/bots/cli.py
#
#

""" console programma voor de enkele gebruiker. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from rechter.defines import GREEN, ENDC
from rechter.main import fleet
from rechter.object import Object
from rechter.bots import Bot
from rechter.cfg import cfg

import time
import sys

## CLI

class CLI(Bot):

    """ bot running on the console. """

    cc = "none"
    default = ""

    def raw(zelf, *args, **kwargs): sys.stdout.write(str(args[0])) ; sys.stdout.write("\n")

    def say(zelf, *args, **kwargs): zelf.raw(args[1])

    def prompt(zelf, *args, **kwargs):
        zelf.wait()
        if cfg.main.colors: return "%s %s<%s " % (time.ctime(time.time()).split()[-2], GREEN, ENDC)
        else: return "%s < " % (time.ctime(time.time()).split()[-2])

    def event(zelf, *args, **kwargs):
        event = Object()
        event._target = zelf
        event.origin = "root@shell"
        zelf.ready()
        event.txt = input(zelf.prompt())
        return event

    def start(zelf, *args, **kwargs):
        fleet.append(zelf)
        if not cfg.main.shell:
            thrs = zelf.single(" ".join(cfg.main.runargs))
            if thrs: zelf.collect(thrs)
            zelf.ready()
            return
        Bot.start(zelf, *args, **kwargs)
 