# clock.py
#
#

""" op de klok geschakeld. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from rechter.utils.time import get_day, get_hour, today, short_date
from rechter.dispatcher import Dispatcher
from rechter.utils.name import named
from rechter.object import Object
from rechter.main import fleet, main

import threading
import logging
import time

# TIMER

class Timer(Object):

    def __init__(zelf, time_alarm, event, *args, **kwargs):
        Object.__init__(zelf, *args, **kwargs)
        zelf.sleep = time_alarm - time.time()
        zelf.event = event

    def start(zelf, *args, **kwargs):
        zelf._timer = threading.Timer(zelf.sleep, zelf.echo)
        zelf._timer.setDaemon(True)
        zelf._timer.setName(named(zelf.echo))
        zelf._timer._start = time.time()
        zelf._timer._last = time.time()
        zelf._timer._status = "start"
        zelf._timer._status = "ok"
        zelf._timer.sleep = zelf.sleep
        logging.warn("# sleeping %s seconds" % zelf.sleep) 
        zelf._timer.start()

    def echo(zelf, *args, **kwargs):
        for bot in fleet: bot.announce(zelf.event.txt)
        zelf.event.done = True
        zelf.event.save()

    def stop(zelf, *args, **kwargs):
        zelf._timer._status = "stopped"
        zelf._timer.cancel()

running = []
        
## LOOPS

class Repeater(Object):

    """ a Repeater calls a function every x seconds. """ 

    def __init__(zelf, sleep, func, *args, **kwargs):
        """ args = function, sleeptime. """
        Object.__init__(zelf, **kwargs)
        zelf.kwargs = kwargs
        zelf.args = args 
        zelf.func = func
        zelf.sleep = sleep
        zelf._start = time.time()
        zelf._status = "start"
        zelf._running = named(zelf.func)

    def start(zelf, *args, **kwargs):
        """ initialize a Looper. """
        zelf._timer = threading.Timer(zelf.sleep, zelf.run)
        zelf._timer.setDaemon(True)
        if "name" in zelf.kwargs: zelf._timer.setName(zelf.kwargs["name"])
        else: zelf._timer.setName(named(zelf.func))
        zelf._timer._nrs = Object()
        zelf._timer._nrs.loops = 0
        zelf._timer._start = time.time()
        zelf._timer._last = time.time()
        zelf._timer._status = "ok"
        zelf._timer.sleep = zelf.sleep
        zelf._timer.start()

    def run(zelf, *args, **kwargs):
        zelf.start()
        zelf._timer._status = "ok"
        zelf._timer._nrs.loops += 1
        zelf.func(**zelf.kwargs)
 
    def exit(zelf, *args, **kwargs):
        zelf._status = ""
        zelf._timer.cancel()

## COMMANDS

def clock_timer(*args, **kwargs):
    rest = args[0].parsed.rest
    if not rest: return
    day = get_day(rest) or today()
    hour = get_hour(rest)
    target = day + get_hour(rest)
    if args: args[0].reply("time found: %s" % short_date(time.ctime(target)))
    else: main.announce("time found: %s" % short_date(time.ctime(target)))
    t = Object()
    t.services = "clock"
    t.prefix = "timer"
    t.txt = rest
    t.time = target
    t.done = False
    t.save()
    timer = Timer(target, t)
    main.put(timer.start)
    args[0].ok()
    logging.warn("# Timer/start %s" % t.json())

main.register("clock.timer", clock_timer)

## INIT

def init():
    for fn in main.all("timer"):
        o = Object().load(fn)
        if time.time() > int(o.time) or o.done: continue
        timer = Timer(int(o.time), o)
        main.put(timer.start)
