# desk.py
#
#

""" show version. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from rechter.main import main, plugins
from rechter.utils.time import elapsed
from rechter.utils.name import naming
from rechter.object import Object
from rechter.cfg import cfg

import threading
import logging
import time
import os

from rechter import __version__

import logging

## DEFINES

txt = " Medicine Effect Registration Program. "

license_txt = """Copyright 2015, B.H.J. Thate

RECHTER - Medicine Effect Registration Program

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.""" 

## CMNDS

def status_uptime(event):
    from rechter.main import main
    event.reply("uptime is %s" % elapsed(time.time() - main._start))
    logging.warn("# Desk/uptime")

main.register("status.uptime", status_uptime)

def desk_copyright(event):
    event.reply(__copyright__)
    logging.warn("# Desk/copyright")

main.register('desk.copyright', desk_copyright)

def desk_version(event):
    event.reply("RECHTER #%s - %s" % (__version__, txt.strip()))
    logging.warn("# Desk/version")

main.register("desk.version", desk_version)

def desk_test(event):
    event.reply("hello %s" % event.origin)
    logging.warn("# Deskt/test")

main.register("desk.test", desk_test)

def desk_ls(event):
    if not event.parsed.rest:
       result = set([x.split(".")[-1] for x in main.names()])
       event.reply(", ".join(sorted(result)))
       return
    name = ""
    keys = main.search(event.parsed.rest)
    if keys: event.reply(", ".join(keys))
    logging.warn("# Desk/ls %s" % len(list(keys)))

main.register("desk.ls", desk_ls)

def desk_local(event):
    if not event.parsed.rest:
       result = set([x.split(".")[-1] for x in main.names() if '.' not in x])
       if result: event.reply(", ".join(sorted(result)))
       return
    name = ""
    keys = main.search(event.parsed.rest)
    if keys: event.reply(", ".join(keys))
    logging.warn("# Desk/local %s" % len(list(keys)))

main.register("desk.local", desk_local)

def desk_plugins(event):
    rest = event.parsed.rest
    if not rest:
       result = set(plugins.names())
       event.reply(", ".join(sorted([".".join(x.split(".")[1:]) for x in result])))
       return
    name = ""
    keys = plugins.search(rest)
    event.reply(", ".join([".".join(x.split(".")[1:]) for x in keys]))
    logging.warn("# Desk/plugins %s" % len(list(keys)))

main.register("desk.plugins", desk_plugins)

def desk_cfg(event):
    bot = event._target
    if bot.type != "CLI":
        botcfg = main.last("cfg", bot.type.lower())
        if not botcfg or "owner" not in botcfg or event.origin != botcfg.owner: event.reply("EOWNER %s" % event.origin) ; return
    obj = cfg
    if event.parsed.args:
        ctype = event.parsed.args[0]
        obj = main.last("cfg", ctype)
        if not obj: obj = cfg.get(ctype, None)
    try: 
        key = event.parsed.args[1]
        value = event.parsed.args[2]
        if key in obj: obj[key] = value ; obj.prefix = "cfg" ; obj.sync()
    except IndexError: pass
    if obj: event.reply("\n".join(obj.show()))
    logging.warn("# Desk/cfg")

main.register("desk.cfg", desk_cfg)

def desk_main(event):
    event.reply(main.pretty())
    logging.warn("# Desk/main")

main.register("desk.main", desk_main)

def desk_where(event):
    name = event.parsed.rest
    cmnds = main.search(name)
    result = []
    for name in cmnds: result.extend([x.plugname for x in main.get(name)])
    if result: event.reply(", ".join(set(result)))
    logging.warn("# Desk/where %s" % len(result))

main.register("desk.where", desk_where)

def desk_ps(event):
    results = []
    for thr in threading.enumerate():
        if str(thr).startswith("<_"): continue
        obj = Object() 
        obj.update(vars(thr))
        txt = naming(thr)
        try: obj = obj.__class__.__self__
        except: pass
        if "_error" in obj: txt += " %s" % obj._error
        if "_status" in obj: txt += " %s" % obj._status
        if "_start" in obj: txt += " %s" % elapsed(int(time.time()) - int(obj._start))
        if "sleep" in obj and "_last" in obj: txt += " next %s/%s" % (elapsed(int(obj.sleep) - int(time.time() - int(obj._last))), elapsed(int(obj.sleep)))
        results.append(txt)
    nr = 0
    for result in sorted(results):
        nr += 1
        event.reply("%s %s" % (nr, result))
    logging.warn("# Desk/ps %s" % nr)
    return nr

main.register("desk.ps", desk_ps)

def desk_usage(event):
    data = os.popen("ps -p %s -o pid,tid,class,rtprio,ni,pri,psr,rss,pcpu,stat,wchan:14,comm" % os.getpid()).read().strip()
    event.reply(str(data))
    logging.warn("# Desk/usage")

main.register("desk.usage", desk_usage)

def desk_license(event):
    event.reply(license_txt)
    logging.warn("# Desk/license")

main.register("desk.license", desk_license)
